__gnu_parallel::_LoserTree< __stable, _Tp, _Compare >(3cxx)

NAME
__gnu_parallel::_LoserTree< __stable, _Tp, _Compare > - Stable _LoserTree variant.

SYNOPSIS

#include <losertree.h>

Inherits __gnu_parallel::_LoserTreeBase< _Tp, _Compare >.

  Public Member Functions

_LoserTree (unsigned int __k, _Compare __comp)
void __delete_min_insert (_Tp __key, bool __sup)
Delete the smallest element and insert a new element from the previously smallest element's sequence.
int __get_min_source ()
void __init ()
unsigned int __init_winner (unsigned int __root)
void __insert_start (const _Tp &__key, int __source, bool __sup)
Initializes the sequence _M_source"withtheelement__key.

  Protected Attributes

unsigned int _M_ik
unsigned int _M_log_k
unsigned int _M_offset

Detailed Description

  template<bool __stable, typename _Tp, typename _Compare>
class __gnu_parallel::_LoserTree< __stable, _Tp, _Compare >"Stable _LoserTree variant.

Provides the stable implementations of insert_start, __init_winner, __init and __delete_min_insert.

Unstable variant is done using partial specialisation below.

Member Function Documentation

  template<bool __stable, typename _Tp, typename _Compare> void __gnu_parallel::_LoserTree< __stable, _Tp, _Compare >::__delete_min_insert (_Tp __key, bool __sup) [inline]

Delete the smallest element and insert a new element from the previously smallest element's sequence. This implementation is stable.

References std::swap().

  template<typename _Tp, typename _Compare> int __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::__get_min_source () [inline], [inherited]

Returns
    the index of the sequence with the smallest element.

References _M_losers.

  template<typename _Tp, typename _Compare> void __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::__insert_start (const _Tp & __key, int __source, bool __sup) [inline], [inherited]

Initializes the sequence "_M_source" with the element "__key".

Parameters
    __key the element to insert
    __source __index of the __source __sequence
    __sup flag that determines whether the value to insert is an explicit __supremum.

References _M_first_insert, and _M_losers.

Member Data Documentation

  template<typename _Tp, typename _Compare> unsigned int __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_log_k [protected], [inherited]
log_2{_M_k}

Referenced by _LoserTreeBase().

Author

Generated automatically by Doxygen for libstdc++ from the source code.